import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This is a white blood cell. This kind of cell has the job to catch 
 * bacteria and remove them from the blood.
 * 
 * @author Michael Kölling
 * @version 0.1
 */
public class Spider extends Actor
{   
    private GreenfootImage image1;
    private GreenfootImage image2;
    private int counter3 =0;
    public Spider()
    {
        image1 = new GreenfootImage("spider2.png");
        image2 = new GreenfootImage("Spider1.png");
        setImage(image1);
    }
    
    public void act() 
    {
        checkKeyPress();
        checkCollision1();
        checkCollision2();
        switchImage();
        counter3 ++;
        move (-2);
        if (getX() == 0) 
            {
            getWorld().removeObject(this);
            Greenfoot.stop();
            }
    }

        public void switchImage()
    {
        if (counter3 ==12)
        {
            if ( getImage() == image1 )
            {
                setImage(image2);
            }
            else
            {
                setImage(image1);
            }
            counter3 =0;
        }
    }
    
    
    /**
     * Check whether a keyboard key has been pressed and react if it has.
     */
    private void checkKeyPress()
    {
        if (Greenfoot.isKeyDown("up")) 
        {
            setLocation(getX(), getY()-8);
        }

        if (Greenfoot.isKeyDown("down")) 
        {
            setLocation(getX(), getY()+8);
        }

        if (Greenfoot.isKeyDown("left"))
        {
            setLocation(getX()-4, getY());
        }

        if (Greenfoot.isKeyDown("right"))
        {
            setLocation(getX()+4, getY());
        }

    }

    public void checkCollision1()
    {
        if (isTouching(Pin.class))
        {
            getWorld().removeObject(this);
            Greenfoot.playSound("game-over.wav");
            Greenfoot.stop();
        }
    }

    public void checkCollision2()
    {
        if (isTouching(Fly.class))
        {
            Greenfoot.playSound("Slap.wav");
            removeTouching(Fly.class);
            Web web = (Web)getWorld();
            web.addScore(20);
        }
    }
}
