import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The web is the setting for our White Blood Cell scenario. 
 * It's a place where blood cells, fly and pin float around.
 * 
 * @author Michael Kölling
 * @version 0.1
 */
public class Web extends World
{
    public int score;
    public int points;
    public int time;

    /**
     * Constructor: Set up the staring objects.
     */
    public Web()
    {    
        super(780, 360, 1); 
        setPaintOrder(Vacuum.class, Lining.class, Pin.class, Fly.class, Spider.class);
        prepare();
        score = 0;
        time = 2000;
        showTime();
    }

    public void act()
    {
        countTime();

        if (Greenfoot.getRandomNumber(100) < 3)
        {
            addObject(new Fly(), 779, Greenfoot.getRandomNumber(360));
        }

        if (Greenfoot.getRandomNumber(100) < 2)
        {
            addObject(new Lining(), 799, 359);
        }

        if (Greenfoot.getRandomNumber(100) < 2)
        {
            addObject(new Lining(), 799, 5);
        }

        if (Greenfoot.getRandomNumber(100) < 1)
        {
            addObject(new Pin(), 779, Greenfoot.getRandomNumber(360));
        }

        if (Greenfoot.getRandomNumber(100) < 6)
        {
            addObject(new Dust(), 779, Greenfoot.getRandomNumber(360));
        }
    }

    private void countTime()
    {
        time--;
        showTime();
        if (time == 0)
        {
            Greenfoot.stop();
            showEndMessage();
        }
    }

    private void showEndMessage()
    {
        showText("Time is up ... YOU WIN" , 400,50);
        showText("Final Score:" + score + " points" , 400, 100);
    }

    private void showTime()
    {
        showText("time:" + time , 710 , 25);
    }

    public void addScore(int points)
    {
        score = score + points;
        showText("Score:" + score , 80, 25);
    }

    public void subtractScore()
    {
        score = score - 15;
    }

    private void prepare()
    {
        Spider spider = new Spider();
        addObject(spider, 130, 174);
        Lining lining = new Lining();
        addObject(lining, 126, 1);
        Lining lining2 = new Lining();
        addObject(lining2, 342, 5);
        Lining lining3 = new Lining();
        addObject(lining3, 589, 2);
        Lining lining4 = new Lining();
        addObject(lining4, 695, 5);
        Lining lining5 = new Lining();
        addObject(lining5, 114, 359);
        Lining lining6 = new Lining();
        Lining lining7 = new Lining();
        addObject(lining7, 295, 353);
        Lining lining8 = new Lining();
        Lining lining9 = new Lining();
        Lining lining10 = new Lining();
        addObject(lining10, 480, 358);
        Lining lining11 = new Lining();
        addObject(lining11, 596, 359);
        Lining lining12 = new Lining();
        addObject(lining12, 740, 354);
        Vacuum vacuum = new Vacuum();
        addObject(vacuum,39,179);
        Vacuum vacuum2 = new Vacuum();
        addObject(vacuum2,742,179);
        vacuum2.setLocation(779,180);
        vacuum.setLocation(0,181);
        spider.setLocation(228,196);
    }
}
